package com.displaynone.acss.components.acs.models.visit

import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.paging.PagingDataAdapter
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.RecyclerView
import com.displaynone.acss.R
import com.displaynone.acss.components.acs.models.visit.repository.dto.VisitDto
import com.displaynone.acss.databinding.ItemScannerViewBinding

class VisitAdapter: PagingDataAdapter<VisitDto, VisitAdapter.ViewHolder>(VisitDiff) {

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        return ViewHolder(
            ItemScannerViewBinding.inflate(
                LayoutInflater.from(parent.context),
                parent,
                false
            )
        )
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        holder.bind(getItem(position) ?:
        VisitDto(
            id = -1,
            userId = -1,
            gateId = -1,
            createdAt = "Loading...",
        )
        )
    }


    class ViewHolder(
        private val binding: ItemScannerViewBinding
    ): RecyclerView.ViewHolder(binding.root) {
        fun bind(item: VisitDto){
            binding.scanTime.text = item.createdAt
            binding.scannerId.text = "Id " + item.gateId.toString()
        }
    }

    object VisitDiff : DiffUtil.ItemCallback<VisitDto>() {
        override fun areItemsTheSame(oldItem: VisitDto, newItem: VisitDto): Boolean {
            return oldItem.id == newItem.id
        }

        override fun areContentsTheSame(oldItem: VisitDto, newItem: VisitDto): Boolean {
            return oldItem == newItem
        }

    }
}